package cn.iocoder.yudao.module.bpm.controller.admin.oa.vo.invoice;

import cn.iocoder.yudao.framework.common.pojo.UploadUserFile;
import cn.iocoder.yudao.module.bpm.controller.admin.oa.vo.BpmOABaseRespVO;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.List;

@Schema(description = "管理后台 - 奖惩申请响应数据 Request VO")
@Data
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class BpmOAInvoiceRespVO extends BpmOABaseRespVO {

    @Schema(description = "计划开票日期", requiredMode = Schema.RequiredMode.REQUIRED)
    private LocalDate invoiceDate;

    @Schema(description = "项目编号")
    private Long projectId;

    @Schema(description = "开票金额", requiredMode = Schema.RequiredMode.REQUIRED)
    private BigDecimal amount;

    @Schema(description = "开票内容", requiredMode = Schema.RequiredMode.REQUIRED)
    private String content;

    @Schema(description = "开票单位名称", requiredMode = Schema.RequiredMode.REQUIRED)
    private String unitName;

    @Schema(description = "开票单位纳税人识别号", requiredMode = Schema.RequiredMode.REQUIRED)
    private String unitTin;

    @Schema(description = "开票单位地址")
    private String unitAddress;

    @Schema(description = "开票单位电话")
    private String unitPhone;

    @Schema(description = "开票单位开户银行")
    private String unitBankName;

    @Schema(description = "开票单位银行账号")
    private String unitBankNo;

    @Schema(description = "关联合同业务流程编号")
    private String contractInstanceId;

    @Schema(description = "上传文件")
    private List<UploadUserFile> fileItems ;
}
